/* Write RIFF/WAVE data to DSP device */

.version "$Id: play.s,v 1.6 2001/12/15 13:59:53 bernd Exp $"
.data
.align 4
dsp_name:
	.asciz "/dev/dsp"
	

/* open flags (/usr/include/bits/fcntl.h) */
O_RDONLY = 00
O_WRONLY = 01
O_RDWR   = 02

/* ioctl parameters 
 *   man ioctl_list
 *   /usr/include/linux/soundcard.h
 */
SNDCTL_DSP_SPEED  = 0xC0045002
SNDCTL_DSP_STEREO = 0xC0045003
SNDCTL_DSP_SETFMT = 0xC0045005


NWAVBUF = 0x2000		# bytes of wave file buffer


.text
/* open WAV-file
 * in: file-name=%ebx
 */
.align 4
.global open_wav
open_wav:
	movl $O_RDONLY,%ecx
	xorl %edx,%edx
	call open
	movl %eax,wav_fd
	ret


/* open DSP device for playing sound
 * in: file-name=%ebx
 */
.align 4
open_dsp:
	movl $O_WRONLY,%ecx
	xorl %edx,%edx
	call open
	movl %eax,dsp_fd
	ret


/* Open DSP device and initialize it
 * according to RIFF/WAVE `fmt' chunk
 */
.align 4
init_dsp:
	leal dsp_name,%ebx
	call open_dsp

/* init DSP with WAV parameters */
	movzwl 2(%esi),%eax	# number channels
	subl $1,%eax
	pushl %eax
        movl %esp,%edx
	movl $SNDCTL_DSP_STEREO,%ecx
	movl dsp_fd,%ebx
	call ioctl

	movzwl 14(%esi),%eax	# bits per sample
	movl %eax,(%esp)
	movl $SNDCTL_DSP_SETFMT,%ecx
	call ioctl
	addl $4,%esp

	leal 4(%esi),%edx	# sample rate
	movl $SNDCTL_DSP_SPEED,%ecx
	call ioctl
	ret


/* play WAV-file
 */
.align 4
.global play
play:
/* read first part of file with `fmt' chunk */
	movl wav_fd,%ebx
	leal wavbuf,%ecx
	movl $NWAVBUF,%edx
	call read

/* check for RIFF/WAVE */
	cmpl $0x46464952,(%ecx)	# RIFF
	jne retrn2
	cmpl $0x45564157,8(%ecx) # WAVE
	jne retrn2

/* check if format tag is PCM format */
	call fmtchunk
	cmpw $1,(%esi)		# PCM
	jne retrn2

	call init_dsp

	call datachunk
	testl %ecx,%ecx
	jz retrn		# zero data chunk length

	movl %ecx,%edi		# whole length of data chunk
	leal wavbuf+NWAVBUF,%edx
	subl %esi,%edx		# %edx=remaining length of wavbuf
	cmpl %edi,%edx
	cmova %edi,%edx		# length
	movl %esi,%ecx		# buffer
	movl dsp_fd,%ebx	
	call write
	subl %edx,%edi
	jbe retrn		# no data left

	movl $NWAVBUF,%edx	# length
	leal wavbuf,%ecx	# buffer

/* reload file buffer */
1:	movl wav_fd,%ebx
	call read

/* compare with remaining data chunk length */
	cmpl %edi,%eax
	cmova %edi,%eax
	
/* write buffer to DSP */
	movl %eax,%edx
	movl dsp_fd,%ebx	
	call write
	subl %eax,%edi		# remaining length of data chunk
	testl %eax,%eax
	jg 1b

retrn:	movl dsp_fd,%ebx
	call close
retrn2:	movl wav_fd,%ebx
	call close
	ret


.bss
.comm  wavbuf,NWAVBUF,16	# read buffer for wave file
.comm  wav_fd,4,4		# wave file descriptor
.align 4
.lcomm dsp_fd,4			# DSP file descriptor
.end
